{***************************************************************}
{*            RichView wrapper for QuickReport                 *}
{***************************************************************}
{*                                                             *}
{* Copyright (c) 2005-2011                                     *}
{*               Henk van Bokhorst / IVS Systemhouse B.V.      *}
{*             & QBS Software                                  *}
{* All rights reserved                                         *}
{*                                                             *}
{***************************************************************}
{*                                                             *}
{* Demo application showing how to use this component          *}
{* I think the code is self-explaining.                        *}
{*                                                             *}
{***************************************************************}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVStyle;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    ChooseFile: TButton;
    FileName: TLabel;
    TBackground: TCheckBox;
    Label2: TLabel;
    ColorMode: TComboBox;
    ShowPreview: TButton;
    PrintBut: TButton;
    Exit: TButton;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ChooseFileClick(Sender: TObject);
    procedure ShowPreviewClick(Sender: TObject);
    procedure PrintButClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
  private
    TheFileName: string;
  public
  end;

var
  Form1: TForm1;

implementation

uses PrtFrm;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  TheFileName := ExtractFilePath(Application.ExeName);
  if TheFileName[Length(TheFileName)] <> '\' then TheFileName := TheFileName + '\';
  TheFileName      := TheFileName + 'ReadMe_RVQRCtrls.rvf';
  FileName.Caption := ExtractFileName(TheFileName);
end;

procedure TForm1.ChooseFileClick(Sender: TObject);
begin
  if OpenDialog1.Execute
  then
  begin
    TheFileName      := OpenDialog1.FileName;
    FileName.Caption := ExtractFileName(TheFileName);
  end;
end;

procedure TForm1.ShowPreviewClick(Sender: TObject);
begin
  PrintForm := TPrintForm.Create(Self);
  PrintForm.QRRichView1.TransparentBackground := TBackground.Checked;
  case ColorMode.ItemIndex of
    0 : PrintForm.QRRichView1.ColorMode := rvcmColor;
    1 : PrintForm.QRRichView1.ColorMode := rvcmPrinterColor;
    2 : PrintForm.QRRichView1.ColorMode := rvcmGrayScale;
    3 : PrintForm.QRRichView1.ColorMode := rvcmBlackAndWhite;
    4 : PrintForm.QRRichView1.ColorMode := rvcmBlackOnWhite;
  end;
  if PrintForm.QRRichView1.LoadRVFFile(TheFileName)
  then PrintForm.QuickRep1.Preview
  else ShowMessage('Error loading document.');
  PrintForm.Release;
end;

procedure TForm1.PrintButClick(Sender: TObject);
begin
  PrintForm := TPrintForm.Create(Self);
  PrintForm.QRRichView1.TransparentBackground := TBackground.Checked;
  case ColorMode.ItemIndex of
    0 : PrintForm.QRRichView1.ColorMode := rvcmColor;
    1 : PrintForm.QRRichView1.ColorMode := rvcmPrinterColor;
    2 : PrintForm.QRRichView1.ColorMode := rvcmGrayScale;
    3 : PrintForm.QRRichView1.ColorMode := rvcmBlackAndWhite;
    4 : PrintForm.QRRichView1.ColorMode := rvcmBlackOnWhite;
  end;
  if PrintForm.QRRichView1.LoadRVFFile(TheFileName)
  then
  begin
    PrintForm.QuickRep1.PrinterSetup;
    if PrintForm.QuickRep1.Tag = 0 then PrintForm.QuickRep1.Print;
  end
  else ShowMessage('Error loading document.');
  PrintForm.Release;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Form1.Close;
end;

end.
