{-------------------------------------------------------------------------
 unit qrd3rdpartycontrol_TRichView

 Include this file in your project and the RichView control will be on the
 QRDesign editor toolbar. qrd3rdpartycontrol_TRichView.res is also required.

 (c) 2010 QBS Software Ltd

 ------------------------------------------------------------------------}

{$I QRDESIGN.INC}

unit qrd3rdpartycontrol_TRichView;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, QRDesign, QRDCtrls,
  quickrpt, RVQRCtrls, RVScroll, RichView, RVEdit, RVStyle;

const
   CRLF = chr(13)+chr(10);
type
  TRVContentType = (ctRTF,ctRVF);

  TRichViewPropEd = class(TForm)
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label2: TLabel;
    CheckBox3: TCheckBox;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
   rvStyle : TRVStyle;
  end;

  TQRDesignRichView = class(TQRRichView)
  private
    FFilename : string;
    FContentType : TRVContentType;
    FContent : string;
    procedure Prepare;override;
  protected
  public
    constructor Create(AOwner: TComponent);override;
    procedure Paint; override;
  published
    property ContentType : TRVContentType read FContentType write FContentType;
    property Content : string read FContent write FContent;
    property AutoStretch;
    property AutoPages;
    property ColorMode;
    property TransparentBackground;
  end;

var
    RichViewPropEd: TRichViewPropEd;
    rvfilename : string;
    fileExtension : string;
    clist : TStringlist;
    tempStream : TMemorystream;

    procedure AsciiHexDecode(sFrom : string; sTo: TMemoryStream);
    procedure AsciiHexEncode(sFrom, sTo: TMemoryStream);
    procedure EditRichView(QRDesigner: TQRepDesigner; Control: TQRPrintable;
                                                      var Result: Boolean);

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}

implementation

{$R *.DFM}

{$R *.RES} { include resource file containing button glyph for report editor }

uses
  {$IFNDEF VER100}
  DBTables,
  {$ENDIF}
  DB, qrd3rdPartyControls, qrdQuickrep, qrdConst;


constructor TQRDesignRichView.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
end;

procedure TQRDesignRichView.Prepare;
begin
    //inherited Prepare;
    if FContent <> '' then
    begin
         tempStream := TMemorystream.Create;
         if ContentType=ctRTF then
         begin
            clist := TStringlist.Create;
            clist.Text := FContent;
            tempstream := TMemorystream.Create;
            clist.SaveToStream(tempStream);
            tempStream.Position := 0;
            self.LoadRTFStream(tempstream);
            clist.Free;
            tempStream.Free;
         end
         else
         if ContentType=ctRVF then
         begin
            tempstream := TMemorystream.Create;
            AsciiHexDecode( FContent, tempstream);
            //tempstream.SaveToFile('binstream.bin');
            tempstream.Position := 0;
            self.LoadRVFStream(tempStream);
            tempstream.Free;
         end;
    end;
end;

procedure TQRDesignRichView.Paint;
begin
  Inherited Paint;
  If (Owner is TDesignQuickreport) Then
    TDesignQuickreport(Owner).ShowComponentFrame(Self);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}

procedure TRichViewPropEd.FormCreate(Sender: TObject);
begin
  TranslateForm(Self, 'TRichViewPropEd');
  combobox1.Items.Add('rvcmColor');
  combobox1.Items.Add('rvcmPrinterColor');
  combobox1.Items.Add('rvcmGrayScale');
  combobox1.Items.Add('rvcmBlackAndWhite');
  combobox1.Items.Add('rvcmBlackOnWhite');

  combobox2.Items.Add('rvf_sIgnore');
  combobox2.Items.Add('rvf_sInsertMap');
  combobox2.Items.Add('rvf_sInsertMerge');

  combobox3.Items.Add('rvf_sIgnore');
  combobox3.Items.Add('rvf_sInsertMap');
  combobox3.Items.Add('rvf_sInsertMerge');

end;

{--------------------------------------------------------------------------------}
{--------------------------------------------------------------------------------}

procedure EditRichView(QRDesigner: TQRepDesigner;
                      Control: TQRPrintable;
                      var Result: Boolean);
var
  QRRT: TQRDesignRichView;
  tstr : string;
  hexstream : TMemorystream;
begin
  QRRT:=TQRDesignRichView(Control);
  RichViewPropEd := TRichViewPropEd.Create(QRDesigner.Owner);
  RichViewPropEd.Edit1.Text := QRRT.Name;
  RichViewPropEd.CheckBox1.Checked := QRRT.AutoStretch;
  RichViewPropEd.CheckBox2.Checked := QRRT.AutoPages;
  RichViewPropEd.CheckBox3.Checked := QRRT.TransparentBackground;
  if QRRT.ColorMode = rvcmColor then
     RichViewPropEd.combobox1.Text := 'rvcmColor'
  else if QRRT.ColorMode = rvcmPrinterColor then
     RichViewPropEd.combobox1.Text := 'rvcmPrinterColor'
  else if QRRT.ColorMode = rvcmGrayScale then
     RichViewPropEd.combobox1.Text := 'rvcmGrayScale'
  else if QRRT.ColorMode = rvcmBlackAndWhite then
     RichViewPropEd.combobox1.Text := 'rvcmBlackAndWhite'
  else if QRRT.ColorMode = rvcmBlackOnWhite then
     RichViewPropEd.combobox1.Text := 'rvcmBlackOnWhite';
  Result := RichViewPropEd.ShowModal = mrOk;
  if Result then
  begin
       QRRT.Name := RichViewPropEd.Edit1.Text;
       QRRT.AutoStretch := RichViewPropEd.CheckBox1.Checked;
       QRRT.AutoPages := RichViewPropEd.CheckBox2.Checked;
       QRRT.TransparentBackground := RichViewPropEd.CheckBox3.Checked;
       // colour option
       if RichViewPropEd.combobox1.Text = 'rvcmColor' then
          QRRT.ColorMode := rvcmColor
       else if RichViewPropEd.combobox1.Text = 'rvcmPrinterColor' then
          QRRT.ColorMode := rvcmPrinterColor
       else if RichViewPropEd.combobox1.Text = 'rvcmGrayScale' then
          QRRT.ColorMode := rvcmGrayScale
       else if RichViewPropEd.combobox1.Text = 'rvcmBlackAndWhite' then
          QRRT.ColorMode := rvcmBlackAndWhite
       else if RichViewPropEd.combobox1.Text = 'rvcmBlackOnWhite' then
          QRRT.ColorMode := rvcmBlackOnWhite;
       // change content if user entered a file name
       if FileExists(rvfilename) then
       begin
            QRRT.FFilename := RVFileName;
            fileExtension := uppercase(ExtractFileExt( QRRT.FFilename));
            clist := TStringlist.Create;
            // set the content.
            if fileExtension ='.RTF' then
            begin
                QRRT.ContentType := ctRTF;
                clist.LoadFromFile(rvfilename);
                QRRT.FContent := clist.Text;
            end
            else if fileExtension ='.RVF' then
            begin
                QRRT.ContentType := ctRVF;
                // encode to asciihex
                tempStream := TMemorystream.Create;
                tempStream.LoadFromFile(rvfilename);
                hexstream := TMemorystream.Create;
                AsciiHexEncode(tempStream, hexstream);
                //hexstream.SaveToFile('hextrace.txt');
                clist.Clear;
                hexstream.Position := 0;
                clist.LoadFromStream(hexstream);
                QRRT.FContent := clist.Text;
                hexstream.Free;
            end;
            clist.Free;
       end;
  end;
  RichViewPropEd.Free;
end;

{------------------------------------------------------------------------------}
procedure TRichViewPropEd.SpeedButton1Click(Sender: TObject);
begin
     if not self.OpenDialog1.Execute then exit;
     rvfilename := self.OpenDialog1.FileName;
end;

{----------------------------------encoding and decoding--------------------------------------------}
function HexToBin( b1, b2 : char ): byte;
begin
   result := 0;
   if (b1 <= '9') and (b1>='0') then
        result := 16*(ord(b1)-ord('0'))
   else if (b1 >= 'A') and (b1<='F') then
        result := 16*(ord(b1)-ord('A') + 10);

   if (b2 <= '9') and (b2>='0') then
        result := result + (ord(b2)-ord('0'))
   else if (b2 >= 'A') and (b2<='F') then
        result := result + (ord(b2)-ord('A') + 10);
end;

procedure AsciiHexDecode(sFrom : string; sTo: TMemoryStream);
var
   outbuff : array [0..999] of Byte;
   K, buffp : longint;
begin
     K := 1;
     buffp := 0;
     while K <= length(sFrom) do
     begin
          outbuff[buffp] := HexToBin( sFrom[K], sFrom[K+1]);
          if buffp = 999 then
          begin
              sTo.WriteBuffer( outbuff, 1000);
              buffp := 0;
          end
          else
              inc(buffp);
          inc(K,2);
     end;
     if buffp > 0 then
        sTo.WriteBuffer( outbuff, buffp);
end;

procedure AsciiHexEncode(sFrom, sTo: TMemoryStream);
const
  REC_SIZE = 2048;
var
  CC: array [0..REC_SIZE] of Byte;
  WasRead: Integer;
  lineout: string;
  I: Integer;

  function BToHex(B: Byte) : ShortString;
    function hx(B: Byte) : Char;
    begin
      if B>9 then Result:=Chr(B+Ord('A')-10) else Result:=Chr(B+Ord('0'))
    end;
  begin
    Result:=hx(B shr 4)+hx(B and $f);
  end;
begin
  sTo.Position:=0;
  sTo.Size:=0;
  sFrom.Position:=0;
  WasRead:=sFrom.Read(CC, REC_SIZE);
  while (WasRead>0) do begin
    lineout:='';
    for I := 0 to WasRead-1 do lineout:=lineout+BToHex(CC[I]);
    //lineout := lineout + CRLF;
    sTo.Write(lineout[1], Length(lineout));
    WasRead:=sFrom.Read(CC, REC_SIZE);
  end;
  sTo.Write(lineout[1], Length(lineout));
end;


procedure TRichViewPropEd.FormClose(Sender: TObject;  var Action: TCloseAction);
begin
     if edit1.Text = '' then
     begin
         showmessage( 'Please give the control a name');
         action := caNone;
     end;
end;

initialization
 // see qrdconst.pas for constants '24' below is the next available.
  RegisterQRDThirdPartyControl( 24,
                                TQRDesignRichView,
                                EditRichView,
                                CreateBitmapFromResource('RICHVIEW'),
                                'QRRichView');
end.
